import java.io.*;
import java.util.*;


public class Build
{

    public Build(RandomAccessFile hed,RandomAccessFile wad,String folder, int version){
        
        try{

        File startingDirectory= new File(folder);
        List<File> files = getFileListing(startingDirectory);
        String filename;
        RandomAccessFile tempfile = null;
        long templong,offset,newoffset,length;
        byte[] buffer;
        int number = 0;

        //loop through all files in a directory
        System.out.printf("\n%-6s%10s%10s   %s\n", "Number","Offset","Length","Name");
        for(File file : files ){
            filename = file.getPath();
            filename = filename.toLowerCase();
            filename = filename.substring( filename.indexOf(folder.toLowerCase()) + folder.length());
            
            tempfile = new RandomAccessFile(file.getPath(), "r");
            offset = wad.getFilePointer();
            newoffset = offset;
            
            if (version != 1){
                newoffset /= 0x800L;
                
                if (version != 9){
                    if (version == 3){
                        if (newoffset >= 0xF0FFFFFFL){
                                //error too big
                                System.out.println("Error: You tried to build a thaw(alt) Wad that is larger than 3.76gb");
                                tempfile.close();
                                wad.close();
                                hed.close();
                                System.exit(0);
                            }
                        newoffset += 0xF000000L;                            
                    }else if (version == 2){
                        if (newoffset >= 0x100000L){
                            if (newoffset >= 0x1FFFFFL){
                                //error too big
                                System.out.println("Error: You tried to build a thaw Wad that is larger than 4gb");
                                tempfile.close();
                                wad.close();
                                hed.close();
                                System.exit(0);
                            }
                            newoffset += 0xFFE00000L;
                        }
                    }
                    
                    
                }else if (newoffset >= 0x7FFFFFFF800L){
                    //error too big
                    System.out.println("Error: Are you serious, you tried to build a file bigger than 8192gb.... Or maybe I made a mistake");
                    tempfile.close();
                    wad.close();
                    hed.close();
                    System.exit(0);
                }
            }else if (newoffset >= 0xFFFFFFFFL){
                //error too big
                System.out.println("Error: You tried to build a thug Wad that is larger than 4gb");
                tempfile.close();
                wad.close();
                hed.close();
                System.exit(0);
            }

            hed.writeInt(Integer.reverseBytes((int)newoffset));  //MAKE SURE TO FIX!!! // I did fix it :)
            
            length = tempfile.length();
            hed.writeInt(Integer.reverseBytes((int)length));
            hed.writeBytes(filename);
            hed.write(new byte[4 - (filename.length()%4)]);
            
            
            if ((number % 100 == 0)|(length >= 0x1FFFFFFFL)){
                System.out.printf("%-6d%10X%10X   %s\n", number, offset, length , filename);
            }

            while (length > 0L){
                if (length >= 0x100000L){
                    buffer = new byte[0x100000];
                    length -= 0x100000L;
                }else{
                    buffer = new byte[(int)length]; //we should always be below 0x100000 bytes here
                    length = 0L;
                }
                tempfile.read(buffer);
                wad.write(buffer);
            }
            
            templong = wad.getFilePointer() % 0x800L;
            templong = 0x800L - templong;
            wad.write(new byte[(int)templong]); //we should always be <= 0x800
            
            tempfile.close();
            number++;

        }
        hed.writeInt(0xFFFFFFFF);
        System.out.println("Finished Building Wad");
    }catch (Exception e){
        System.out.println("Error in build function");
        System.out.println(e);
    }
    }
  
    
//The following is borrowed from http://www.javapractices.com/topic/TopicAction.do?Id=68    
    
  /**
* Recursive file listing under a specified directory.
*  
* @author javapractices.com
* @author Alex Wong
* @author anonymous user
*/

  
  /**
  * Recursively walk a directory tree and return a List of all
  * Files found; the List is sorted using File.compareTo().
  *
  * @param aStartingDir is a valid directory, which can be read.
  */
  static public List<File> getFileListing(
    File aStartingDir
  ) throws FileNotFoundException {
    validateDirectory(aStartingDir);
    List<File> result = getFileListingNoSort(aStartingDir);
    Collections.sort(result);
    return result;
  }

  // PRIVATE //
  static private List<File> getFileListingNoSort(
    File aStartingDir
  ) throws FileNotFoundException {
    List<File> result = new ArrayList<File>();
    File[] filesAndDirs = aStartingDir.listFiles();
    List<File> filesDirs = Arrays.asList(filesAndDirs);
    for(File file : filesDirs) {

        if (file.isFile() ) {
            result.add(file); 
        }else{
        //must be a directory
        //recursive call!
        List<File> deeperList = getFileListingNoSort(file);
        result.addAll(deeperList);
      }
    }
    return result;
  }

  /**
  * Directory is valid if it exists, does not represent a file, and can be read.
  */
  static private void validateDirectory (
    File aDirectory
  ) throws FileNotFoundException {
    if (aDirectory == null) {
      throw new IllegalArgumentException("Directory should not be null.");
    }
    if (!aDirectory.exists()) {
      throw new FileNotFoundException("Directory does not exist: " + aDirectory);
    }
    if (!aDirectory.isDirectory()) {
      throw new IllegalArgumentException("Is not a directory: " + aDirectory);
    }
    if (!aDirectory.canRead()) {
      throw new IllegalArgumentException("Directory cannot be read: " + aDirectory);
    }
  }
    
    
}
